<template>
  <div id="d3-ra-dec-chart" />
</template>
<script>
/* eslint-disable eqeqeq, @typescript-eslint/no-this-alias, no-mixed-operators */
import Vue from 'vue';
import * as d3 from 'd3';
import { LocusService } from '@/api';
import * as charts from '@/vis/chartTyped';

export default Vue.extend({
  props: {
    alerts: {
      type: Array,
      default: () => [],
    },
    locus: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      chart: {
        width: 250,
        height: 250,
        margin: 25,
      },
      dataGroup: null,
      nearbyLoci: [],
    };
  },
  watch: {
    alerts() {
      this.plot();
    },
    // nearbyLoci() {}, // TODO: This line should be removed since it does nothing
  },
  beforeDestroy() {
    this.chartsUnwatch();
  },
  mounted() {
    charts.chartStore.commit('createChartGroup', 'default');
    let prevFill = null;
    this.chartsUnwatch = charts.chartStore.watch((state) => {
      const { fill } = state.chartGroups.default.annotations;
      if (prevFill !== fill) {
        prevFill = fill;
      }
      return fill;
    }, () => {
      this.refreshCharts();
    });

    const svg = d3
      .select('#d3-ra-dec-chart')
      .append('svg')
      .attr('width', this.chart.width)
      .attr('height', this.chart.height);
    this.svg = svg;
    const scales = this.scales();
    const { ra, dec } = scales;
    const aG = svg.append('g'); // annotations
    charts.chartStore.commit('predicate', {
      group: 'default',
      chartName: 'ra-dec',
      predicate: null,
    });

    aG.append('g')
      .selectAll('circle')
      // These values should be the radii, in arcsec, of the circles we use for
      // gridlines on the plot. For some reason, though, they don't seem to
      // make sense on the coordinate system? Larger radius shrinks the circle,
      // e.g. We need to roll this change out so I've visually matched up the
      // gridlines with where they should be.
      .data([0.37 / 3600, 0.87 / 3600, 1.37 / 3600])
      .enter()
      .append('circle')
      .attr('cx', ra(0))
      .attr('cy', dec(0))
      .attr('r', (d) => dec(d))
      .attr('stroke', d3.lab(90, 0, 0))
      .attr('fill', 'none');

    aG.append('g')
      .selectAll('line')
      .data(['ra', 'dec'])
      .enter()
      .append('line')
      .attr('stroke', d3.lab(90, 0, 0))
      .attr('x1', (d) => ra(-1 * (d === 'ra' ? 1.5 / 3600 : 0)))
      .attr('x2', (d) => ra((d === 'ra' ? 1.5 / 3600 : 0)))
      .attr('y1', (d) => dec(-1 * (d === 'dec' ? 1.5 / 3600 : 0)))
      .attr('y2', (d) => dec((d === 'dec' ? 1.5 / 3600 : 0)));

    aG.append('g')
      .selectAll('text')
      .data([
        {
          label: 'DEC+',
          textAnchor: 'middle',
          ra: 0,
          dec: 1.55 / 3600,
        },
        {
          label: 'RA-',
          dominantBaseline: 'middle',
          ra: -1.48 / 3600,
          dec: 0,
        },
        {
          label: '0.5"',
          textAnchor: 'end',
          ra: 0,
          dec: 0.575 / 3600,
        },
        {
          label: '1"',
          textAnchor: 'end',
          ra: 0,
          dec: 1.075 / 3600,
        },
      ])
      .enter()
      .append('text')
      .style('font-family', 'Raleway, sans-serif')
      .style('fill', d3.rgb('#2c3e50').brighter()) // TODO grab this from CSS
      .attr('x', (d) => ra(d.ra))
      .attr('y', (d) => dec(d.dec))
      .style('dominant-baseline', (d) => d.dominantBaseline)
      .style('text-anchor', (d) => d.textAnchor)
      .text((d) => d.label);

    this.dataGroup = svg.append('g');

    this.fetchNearbyLoci();
  },
  methods: {
    scales() {
      return {
        ra: d3
          .scaleLinear()
          .domain([1.5 / 3600, -1.5 / 3600])
          .range([this.chart.margin, this.chart.width - this.chart.margin]),
        dec: d3
          .scaleLinear()
          .domain([-1.5 / 3600, 1.5 / 3600])
          .range([this.chart.height - this.chart.margin, this.chart.margin]),
        passband: charts.passbandScale(),
      };
    },
    async fetchNearbyLoci() {
      let { data: nearbyLoci } = await LocusService.coneSearch(
        `${this.locus.ra} ${this.locus.dec}`,
        1.5 / 3600.0,
        {
          page: {
            limit: 100,
          },
          fields: {
            locus_listing: 'ra,dec',
          },
        },
      );
      nearbyLoci = nearbyLoci.filter((locus) => locus.id != this.locus.id);
      this.nearbyLoci = nearbyLoci;
    },
    refreshCharts() {
      const { dataGroup } = this;
      const state = charts.chartStore.state.chartGroups.default;
      if (!state.annotations.fill) return;
      dataGroup.selectAll('g circle')
        .attr('fill', (d) => {
          const id = d.payload.alert_id;
          return state.annotations.fill.get(id);
        });
    },
    plot() {
      const { ra, dec, passband } = this.scales();
      const { dataGroup } = this;
      const that = this;

      function translateRaDec(d) {
        const raSep = (d.payload.ant_ra - that.locus.ra) * Math.cos(that.locus.dec * Math.PI / 180);
        const decSep = d.payload.ant_dec - that.locus.dec;
        return `translate(${ra(raSep)},${dec(decSep)})`;
      }

      const pts = this.locus.lightcurve.filter(
        (d) => (d.frontend_mag_type === 'calibrated'
              || d.frontend_mag_type === 'raw'),
      )
        .map((d) => ({
          type: 'mag',
          payload: d,
          getMag() {
            return this.payload.frontend_mag;
          },
        }));

      dataGroup
        .selectAll('g')
        .data(pts, (d) => d.alert_id)
        .enter()
        .append('g')
        .attr('transform', (d) => translateRaDec(d))
        .append('circle')
        .attr('r', 2)
        .attr('fill', (d) => passband(d.payload.ant_passband));

      charts.watchBrush('default', () => {
        const predicate = charts.getSelectionPredicate('default', 'ra-dec');

        dataGroup
          .selectAll('g')
          .style('opacity', (d) => {
            if (predicate(d)) {
              return null;
            }
            return 0.1;
          });

        // 2020-12-09, cscheid:
        // in previous versions of the code, we would raise() all opaque elements to the front, and
        // set the other opacities to 0.1.
        // after profiling our code, I learned that raise() is responsible for a good chunk
        // of our running time during brushing; it makes the visualization look a little better,
        // but it's not really _quite_ necessary and the jank is more problematic. Let's
        // skip it for now.
      });

      function brushed(event) {
        if (event.selection) {
          const [[x0, y0], [x1, y1]] = event.selection;
          const [xMin, xMax] = d3.extent([x0, x1]);
          const [yMin, yMax] = d3.extent([y0, y1]);
          charts.chartStore.commit('predicate', {
            group: 'default',
            name: 'ra-dec',
            predicate: (d) => {
              const raValue = d.payload.ant_ra;
              const decValue = d.payload.ant_dec;

              // we filter out things without RA or DEC (like mags)
              if (!raValue || !decValue) {
                return false;
              }
              const raSep = (d.payload.ant_ra - that.locus.ra)
                * Math.cos(that.locus.dec * Math.PI / 180);
              const decSep = d.payload.ant_dec - that.locus.dec;

              const vRa = ra(raSep);
              if (vRa < xMin || vRa > xMax) return false;
              const vDec = dec(decSep);
              return (yMin <= vDec && vDec <= yMax);
            },
          });
          charts.triggerRedraw('default');
        } else {
          charts.chartStore.commit('predicate', {
            group: 'default',
            name: 'ra-dec',
            predicate: null,
          });
          charts.triggerRedraw('default');
        }
      }

      this.brushGroup = this.svg.append('g');
      this.brushGroup.attr('class', 'brush').call(d3.brush().on('start brush end', brushed));
    },
  },
});
</script>
